#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf lpr_2008.05.17.tar.gz
    cd lpr
    bunzip2 -c ../lpr_2008.05.17-dietpc-patch.bz2 | patch -p1 -b
    make .CURDIR=.
    strip -R .note -R .comment lpq/lpq lpr/lpr lprm/lprm lpc/lpc lpd/lpd
    mkdir -p ../lpd/bin ../lpd/sbin
    cp lpq/lpq lpr/lpr lprm/lprm ../lpd/bin/
    chmod ug+s ../lpd/bin/*
    cp lpc/lpc lpd/lpd ../lpd/sbin/
    cd ..
    rm -rf lpr
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
